#include <windows.h>
//#include <vcl\vcl.h>
#include <string.h>
#include <stdio.h>
#include <io.h>
#include <time.h>
#include <mbstring.h>
#include <tlhelp32.h>
#include "ese_general.h"
#include "ese_global.h"
#include "ese_dokoitsu.h"
#include "ese_db.h"
#include "ese_common.h"

//---------------------------------------------------------------------------
//#define DEBUG 1

int GSaoriNum;						//[hςSAORIo^
StrSaoriInfo GSaoriInfo[SAORI_MAX];	//[hςSAORIf[^

int load_saori(void);
int unload_saori(void);
int access_saori_single(char* buf);
int access_saori_multi(char* buf);
int access_saori( char* path, int argc, char* argv[], char* outbuf );

extern int remove_function(char* buf);
extern int set_stack(char* buf, char* get_str, int stack_no, int mode);


/************************************************************************/
/*						SAORĨ[h								*/
/************************************************************************/
int load_saori(void)
{
	FILE* fp_read;
	HINSTANCE hdl;
	char wrk[2048];
	char listpath[MAX_PATH];
	char dllpath[MAX_PATH];
	char* p_wrk;
	unsigned char wrkc;
	int loop_cnt;
	int saori_num;
	int last_point;
	
	/*  */
	GSaoriNum = 0;
	for( loop_cnt = 0; loop_cnt < SAORI_MAX; loop_cnt++ ){
		GSaoriInfo[loop_cnt].saori_path  = NULL;
	}
	
	/* Xgt@CI[v */
	strcpy( listpath, GlobalPath );
	strcat( listpath, SAORI_LIST_FILE );
	fp_read = fopen( listpath, "rt" );
	if( fp_read == NULL )return(1);
	
	/* Ps[h */
	for( saori_num = 0; saori_num < SAORI_MAX; ){
		if( fgets( wrk, 2040, fp_read ) == NULL )break;
		
		/* s폜 */
		p_wrk = strchr( wrk, '\r' );
		if( p_wrk != NULL )*p_wrk = '\0';
		p_wrk = strchr( wrk, '\n' );
		if( p_wrk != NULL )*p_wrk = '\0';
		
		/* dllpX쐬 */
		strcpy( dllpath, GlobalPath );
		strcat( dllpath, wrk );
		
		/* t@C".\""..\"݂ꍇ͎gpsƂ */
		if( strstr( dllpath, ".\\" ) != NULL )continue;
		
		/* dll̑݊mF */
		if( access( dllpath, 0 ) != 0 )continue;
		
		/* pXi[ */
		p_wrk = (char*)malloc( strlen( dllpath )+4 );
		if( p_wrk == NULL )continue;
		strcpy( p_wrk, dllpath );
		
		log_write_user( dllpath, "ese_saori.log", GSaoriLog );
		log_write_user( "-> long life load.", "ese_saori.log", GSaoriLog );
		
		/* dllǂݍ */
		hdl = LoadLibrary( dllpath );
		if( hdl == NULL ){
			free( p_wrk );
			continue;
		}
		
		/* load֐擾 */
		BOOL (FAR __cdecl *ai_load)( HGLOBAL h, long len );
		(FARPROC&)ai_load = GetProcAddress( hdl, "load" );
		if( ai_load == NULL ){
			FreeLibrary( hdl );
			free( p_wrk );
			continue;
		}
		/* load֐ւ̈ipXj쐬 */
		strcpy( wrk, dllpath );
		for( loop_cnt = 0; wrk[loop_cnt] != '\0'; loop_cnt++ ){
			wrkc = (unsigned char)wrk[loop_cnt];
			if( wrkc >= 0x81 && wrkc <= 0x9f || wrkc >= 0xe0 && wrkc <= 0xfc ){
				/* QoCgȂ̂Ŕ΂ */
				loop_cnt++;
				if( wrk[loop_cnt] == '\0' )break;
				continue;
			}
			if( wrkc == '\\' ){
				last_point = loop_cnt;
				continue;
			}
		}
		wrk[last_point+1] = '\0';
		/* load֐s */
		HGLOBAL mem_hndl = GlobalAlloc( GMEM_FIXED, strlen(wrk) );
		memcpy( (char *)GlobalLock(mem_hndl), wrk, strlen(wrk) );
		long len = (long)strlen(wrk);
		if( ! ai_load( mem_hndl, len ) ){
			FreeLibrary( hdl );
			free( p_wrk );
			continue;
		}
		
		/* request֐擾 */
		HGLOBAL (FAR __cdecl *ai_request)( HGLOBAL h, long* len );
		(FARPROC&)ai_request = GetProcAddress( hdl, "request" );
		if( ai_request == NULL ){
			FreeLibrary( hdl );
			free( p_wrk );
			continue;
		}
		/* o[W擾 */
		strcpy( wrk, "GET Version SAORI/1.0\r\n" );
		strcat( wrk, "SecurityLevel: Local\r\n" );
		strcat( wrk, "Charset: Shift_JIS\r\n" );
		strcat( wrk, "Sender: eseshiori\r\n" );
		strcat( wrk, "\r\n" );
		mem_hndl = GlobalAlloc( GMEM_FIXED, strlen(wrk) );
		memcpy( (char *)GlobalLock(mem_hndl), wrk, strlen(wrk) );
		len = (long)strlen(wrk);
		HGLOBAL get_hndl;
		get_hndl = ai_request( mem_hndl, &len );
		GlobalFree(get_hndl);//ʓ|Ȃ̂Ńo[W͌Ɏ̂Ă
		
		/* SĂnjȂ̂dllo^ */
		GSaoriInfo[saori_num].saori_path  = p_wrk;
		log_write_user( GSaoriInfo[saori_num].saori_path, "ese_saori.log", GSaoriLog );
		GSaoriInfo[saori_num].hdl  = hdl;
		saori_num++;
		
	}
	
	/* 擾saori̐Zbg */
	GSaoriNum = saori_num;
	
	fclose(fp_read);
	
	return(0);
	
}


/************************************************************************/
/*						SAORĨA[h							*/
/************************************************************************/
int unload_saori(void)
{
	int loop_cnt;
	
	for( loop_cnt = 0; loop_cnt < GSaoriNum; loop_cnt++ ){
		
		/* unloads */
		BOOL (FAR __cdecl *ai_unload)( void );
		(FARPROC&)ai_unload = GetProcAddress( GSaoriInfo[loop_cnt].hdl, "unload" );
		if( ai_unload != NULL )ai_unload();
		
		/* J */
		FreeLibrary( GSaoriInfo[loop_cnt].hdl );
		free( GSaoriInfo[loop_cnt].saori_path );
		GSaoriInfo[loop_cnt].saori_path = NULL;
	}
	
	return(0);
	
}


/************************************************************************/
/*						SAORIANZXP߂l							*/
/************************************************************************/
int access_saori_single(char* buf)
{
	
	char dllpath[MAX_PATH+2];
	char wrk[2048];
	char wrk2[2048];
	char* argv[128];
	char* p_wrk = buf;
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	int loop_cnt;
	int argc;
	int ret_cd;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾 */
	get_comma_lenword( p_wrk, wrk, 0, MAX_PATH );
	delete_doublequotation( wrk );
	strcpy( dllpath, GlobalPath );
	strcat( dllpath, wrk );
	
	if( access( dllpath, 0 ) != 0 ){
		/* dll݂Ȃ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* t@C".\""..\"݂ꍇ͎gpsƂ */
	if( strstr( dllpath, ".\\" ) != NULL ){
		/* gpsȂ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* Qȍ~̕^Cv̂̂擾 */
	for( loop_cnt = 0; loop_cnt < 128; loop_cnt++ )argv[loop_cnt] = NULL;
	for( loop_cnt = 0; loop_cnt < 128; loop_cnt++ ){
		get_comma_lenword( p_wrk, wrk, loop_cnt+1, 126 );
		if( wrk[0] == '\"' ){
			delete_doublequotation( wrk );
			argv[loop_cnt] = (char*)malloc( strlen(wrk)+1 );
			strcpy( argv[loop_cnt], wrk );
		}
		else{
			/* SAORI͏ÎŎii[ʒuj */
			argc = loop_cnt;
			break;
		}
	}
	
	/* i[ʒuE\ۃtO擾 */
	loop_cnt++;
	get_comma_lenword( p_wrk, wrk, loop_cnt, 126 );
	sscanf( wrk, " %d", &stack_no );
	loop_cnt++;
	get_comma_lenword( p_wrk, wrk, loop_cnt, 126 );
	sscanf( wrk, " %d", &mode );
	
	/* SAORIփANZX */
	if( access_saori( dllpath, argc, argv, wrk ) != 0 ){
		strcpy( wrk, "SAORI/1.0 500" );
	}
	
	/* ANZXʂ擾 */
	if( memlcmp( wrk, "SAORI/1.0 400" ) == 0 ||
		memlcmp( wrk, "SAORI/1.0 500" ) == 0 ){
		/* SAORIG[ */
		remove_function( buf );
		ret_cd = 1;
	}
	else if( memlcmp( wrk, "SAORI/1.0 204" ) == 0 ){
		/* ߂liV */
		remove_function( buf );
		ret_cd = 0;
	}
	else if( memlcmp( wrk, "SAORI/1.0 200" ) == 0 ){
		/* ߂l擾 */
		ret_cd = 0;
		p_wrk = strstr( wrk, "\r\nResult: " );
		if( p_wrk == NULL ){
			remove_function( buf );
		}
		else{
			p_wrk+= strlen( "\r\nResult: " );
			strcpy( wrk2, p_wrk );
			p_wrk = strstr( wrk2, "\r\n" );
			if( p_wrk != NULL )*p_wrk = '\0';
			
			/* ɏ]ďiLyъ֐Euj */
			set_stack(buf, wrk2, stack_no, mode);
		}
	}
	else{
		/* ٗlȒlԂėꍇ */
		/* SAORIG[ */
		remove_function( buf );
		ret_cd = 1;
	}
	
	
	/* J */
	for( loop_cnt = 0; loop_cnt < 128; loop_cnt++ ){
		if( argv[loop_cnt] != NULL )free(argv[loop_cnt]);
	}
	
	return(ret_cd);
	
}


/************************************************************************/
/*						SAORIANZX߂l							*/
/************************************************************************/
int access_saori_multi(char* buf)
{
	
	char dllpath[MAX_PATH+2];
	char wrk[2048];
	char wrk2[2048];
	char* argv[128];
	char* p_wrk = buf;
	int start_no = 0;
	int end_no = 0;
	int now_no;
	int loop_cnt;
	int argc;
	int ret_cd;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾 */
	get_comma_lenword( p_wrk, wrk, 0, MAX_PATH );
	delete_doublequotation( wrk );
	strcpy( dllpath, GlobalPath );
	strcat( dllpath, wrk );
	
	if( access( dllpath, 0 ) != 0 ){
		/* dll݂Ȃ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* t@C".\""..\"݂ꍇ͎gpsƂ */
	if( strstr( dllpath, ".\\" ) != NULL ){
		/* gpsȂ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* Qȍ~̕^Cv̂̂擾 */
	for( loop_cnt = 0; loop_cnt < 128; loop_cnt++ )argv[loop_cnt] = NULL;
	for( loop_cnt = 0; loop_cnt < 128; loop_cnt++ ){
		get_comma_lenword( p_wrk, wrk, loop_cnt+1, 126 );
		if( wrk[0] == '\"' ){
			delete_doublequotation( wrk );
			argv[loop_cnt] = (char*)malloc( strlen(wrk)+1 );
			strcpy( argv[loop_cnt], wrk );
		}
		else{
			/* SAORI͏ÎŎii[ʒuj */
			argc = loop_cnt;
			break;
		}
	}
	
	/* i[ʒu擾 */
	loop_cnt++;
	get_comma_lenword( p_wrk, wrk, loop_cnt, 126 );
	sscanf( wrk, " %d", &start_no );
	loop_cnt++;
	get_comma_lenword( p_wrk, wrk, loop_cnt, 126 );
	sscanf( wrk, " %d", &end_no );
	
	/* i[ʒu */
	start_no--;
	end_no--;
	now_no = start_no;
	if( start_no == -1 || end_no == -1 ){
		/* ̒l̂ŏI */
		for( loop_cnt = 0; loop_cnt < 128; loop_cnt++ ){
			if( argv[loop_cnt] != NULL )free(argv[loop_cnt]);
		}
		remove_function(buf);
		return(0);
	}
	
	/* SAORIփANZX */
	if( access_saori( dllpath, argc, argv, wrk ) != 0 ){
		strcpy( wrk, "SAORI/1.0 500" );
	}
	
	/* ANZXʂ擾 */
	if( memlcmp( wrk, "SAORI/1.0 400" ) == 0 ||
		memlcmp( wrk, "SAORI/1.0 500" ) == 0 ){
		/* SAORIG[ */
		remove_function( buf );
		ret_cd = 1;
	}
	else if( memlcmp( wrk, "SAORI/1.0 204" ) == 0 ){
		/* ߂liV */
		remove_function( buf );
		ret_cd = 0;
	}
	else if( memlcmp( wrk, "SAORI/1.0 200" ) == 0 ){
		/* ߂l擾 */
		ret_cd = 0;
		for( loop_cnt = 0; loop_cnt < 128; loop_cnt++ ){
			/* Yʂ̃AhX擾 */
			sprintf( wrk2, "\r\nValue%d: ", loop_cnt );
			p_wrk = strstr( wrk, wrk2 );
			if( p_wrk == NULL )continue;
			
			/* f[^擾 */
			p_wrk+=strlen(wrk2);
			strcpy( wrk2, p_wrk );
			p_wrk = strstr( wrk2, "\r\n" );
			if( p_wrk != NULL )*p_wrk = '\0';
			
			/* mۂĎ[ */
			if( now_no >= 0 ){
				free_target_paragraph( now_no );
				if( wrk2[0] == '\0' ){
					/* OoCg̒̎̓mۂȂ */
				}
				else if( ( GStack[now_no] = (char*)malloc( strlen(wrk2)+1 )) != NULL ){
					/* eRs[ */
					strcpy( GStack[now_no], wrk2 );
				}
				else{
					/* mێs */
					GStack[now_no] = NULL;
				}
			}
			
			/* i[ʒuړiIʒu܂œǂ񂾂Ij */
			now_no++;
			if( now_no > end_no )break;
		}
		
		/* ValuelꍇAResultl擾Ċi[ʒu擪ɃZbg */
		if( now_no == start_no ){
			p_wrk = strstr( wrk, "\r\nResult: " );
			if( p_wrk != NULL ){
				p_wrk+= strlen( "\r\nResult: " );
				strcpy( wrk2, p_wrk );
				p_wrk = strstr( wrk2, "\r\n" );
				if( p_wrk != NULL )*p_wrk = '\0';
				
				if( now_no >= 0 ){
					free_target_paragraph( now_no );
					if( wrk2[0] == '\0' ){
						/* OoCg̒̎̓mۂȂ */
					}
					else if( ( GStack[now_no] = (char*)malloc( strlen(wrk2)+1 )) != NULL ){
						/* eRs[ */
						strcpy( GStack[now_no], wrk2 );
					}
					else{
						/* mێs */
						GStack[now_no] = NULL;
						ret_cd = 1;
					}
				}
			}
		}
		
		/* ֐ */
		remove_function( buf );
	}
	else{
		/* ٗlȒlԂėꍇ */
		/* SAORIG[ */
		remove_function( buf );
		ret_cd = 1;
	}
	
	/* J */
	for( loop_cnt = 0; loop_cnt < 128; loop_cnt++ ){
		if( argv[loop_cnt] != NULL )free(argv[loop_cnt]);
	}
	
	return(ret_cd);
	
}

/************************************************************************/
/*						SAORIɃANZX								*/
/************************************************************************/
#define SAORI_LIFE_LONG		0
#define SAORI_LIFE_SHORT	1
int access_saori( char* path, int argc, char* argv[], char* outbuf )
{
	HGLOBAL (FAR __cdecl *ai_request)( HGLOBAL h, long* len );
	HGLOBAL mem_hndl;
	HGLOBAL get_hndl;
	HINSTANCE hdl;
	char wrk[4096];
	char wrk2[256];
	unsigned char wrkc;
	long len;
	int loop_cnt;
	int last_point;
	int long_short_flg;
	
	log_write_user( path, "ese_saori.log", GSaoriLog );
	
	/* saoriǂmF */
	for( loop_cnt = 0; loop_cnt < GSaoriNum; loop_cnt++ ){
		log_write_user( path, "ese_saori.log", GSaoriLog );
		log_write_user( GSaoriInfo[loop_cnt].saori_path, "ese_saori.log", GSaoriLog );
		if( strcmp( GSaoriInfo[loop_cnt].saori_path, path ) == 0 )break;
	}
	if( loop_cnt == GSaoriNum )long_short_flg = SAORI_LIFE_SHORT;
	else					   long_short_flg = SAORI_LIFE_LONG;
	
	/* SAORIZ̏ꍇdll[hyload֐s,o[W擾s */
	if( long_short_flg == SAORI_LIFE_SHORT ){
		
		log_write_user( "-> short life.", "ese_saori.log", GSaoriLog );
		
		/* dllǂݍ */
		hdl = LoadLibrary( path );
		if( hdl == NULL ){
			return(1);
		}
		
		/* load֐擾 */
		BOOL (FAR __cdecl *ai_load)( HGLOBAL h, long len );
		(FARPROC&)ai_load = GetProcAddress( hdl, "load" );
		if( ai_load == NULL ){
			FreeLibrary( hdl );
			return(1);
		}
		/* load֐ւ̈ipXj쐬 */
		strcpy( wrk, path );
		for( loop_cnt = 0; wrk[loop_cnt] != '\0'; loop_cnt++ ){
			wrkc = (unsigned char)wrk[loop_cnt];
			if( wrkc >= 0x81 && wrkc <= 0x9f || wrkc >= 0xe0 && wrkc <= 0xfc ){
				/* QoCgȂ̂Ŕ΂ */
				loop_cnt++;
				if( wrk[loop_cnt] == '\0' )break;
				continue;
			}
			if( wrkc == '\\' ){
				last_point = loop_cnt;
				continue;
			}
		}
		wrk[last_point+1] = '\0';
		/* load֐s */
		mem_hndl = GlobalAlloc( GMEM_FIXED, strlen(wrk) );
		memcpy( (char *)GlobalLock(mem_hndl), wrk, strlen(wrk) );
		len = (long)strlen(wrk);
		ai_load( mem_hndl, len );
		
		/* request֐擾 */
		(FARPROC&)ai_request = GetProcAddress( hdl, "request" );
		if( ai_request == NULL ){
			FreeLibrary( hdl );
			return(1);;
		}
		/* o[W擾 */
		strcpy( wrk, "GET Version SAORI/1.0\r\n" );
		strcat( wrk, "SecurityLevel: Local\r\n" );
		strcat( wrk, "Charset: Shift_JIS\r\n" );
		strcat( wrk, "Sender: eseshiori\r\n" );
		strcat( wrk, "\r\n" );
		mem_hndl = GlobalAlloc( GMEM_FIXED, strlen(wrk) );
		memcpy( (char *)GlobalLock(mem_hndl), wrk, strlen(wrk) );
		len = (long)strlen(wrk);
		get_hndl = ai_request( mem_hndl, &len );
		GlobalFree(get_hndl);//ʓ|Ȃ̂Ńo[W͌Ɏ̂Ă
	}
	else{
		
		log_write_user( "-> long life.", "ese_saori.log", GSaoriLog );
		
		/* o^ςdllnh擾 */
		hdl = GSaoriInfo[loop_cnt].hdl;
		
		/* request֐擾 */
		(FARPROC&)ai_request = GetProcAddress( hdl, "request" );
		if( ai_request == NULL ){
			FreeLibrary( hdl );
			return(1);;
		}
	}
	
	/* NGXg쐬 */
	strcpy( wrk, "EXECUTE SAORI/1.0\r\n" );
	strcat( wrk, "SecurityLevel: Local\r\n" );
	for( loop_cnt = 0; loop_cnt < argc; loop_cnt++ ){
		sprintf(wrk2, "Argument%d: %s\r\n", loop_cnt, argv[loop_cnt] );
		strcat( wrk, wrk2 );
	}
	strcat( wrk, "Charset: Shift_JIS\r\n" );
	strcat( wrk, "Sender: eseshiori\r\n" );
	strcat( wrk, "\r\n" );
	
	log_write_user( wrk, "ese_saori.log", GSaoriLog );
	
	/* NGXgs */
	mem_hndl = GlobalAlloc( GMEM_FIXED, strlen(wrk) );
	memcpy( (char *)GlobalLock(mem_hndl), wrk, strlen(wrk) );
	len = (long)strlen(wrk);
	get_hndl = ai_request( mem_hndl, &len );
	memcpy( wrk, (char *)GlobalLock(get_hndl), len );
	wrk[len] = '\0';
	strcpy( outbuf, wrk );
	GlobalFree(get_hndl);
	
	log_write_user( wrk, "ese_saori.log", GSaoriLog );
	
	/* SAORIZ̏ꍇunload֐sydllA[hs */
	if( long_short_flg == SAORI_LIFE_SHORT ){
		/* unloads */
		BOOL (FAR __cdecl *ai_unload)( void );
		(FARPROC&)ai_unload = GetProcAddress( hdl, "unload" );
		if( ai_unload == NULL ){
			FreeLibrary( hdl );
			return(1);
		}
		ai_unload();
		
		/* DLLJ */
		FreeLibrary( hdl );
	}
	
	return(0);
}
